package Site::SQLFieldForeignKey;
# LICENSE
#
# Copyright (c) 2001 Steve Slaven <bpk@hoopajoo.net> All rights reserved.
#
# This program is free software  and is provided "as is" without
# express or implied warranty. You can redistribute it and/or
# modify it under the same terms as Perl itself.
#

use strict;
use vars qw( @ISA %AUTOFIELDS $AUTOSETTINGS );

use Site::SQLFieldBase;
@ISA = qw( Site::SQLFieldBase );

$AUTOSETTINGS = 1;
%AUTOFIELDS = (
		rowsourcequery => undef,
		rowsourcetype => 'list',
		rowsourcevalues => undef # If set up by the user, use an
					# arrayref of hashrefs
	);

sub _HTMLFIELD
{
	my $Self = shift;
	my $Ret;
	my $Selected;

	$Self -> _FillList();
	return( $Self -> __HTMLField() );
}

sub _HTMLDISPLAYVALUE
{
	my $Self = shift;

	$Self -> _FillList();
	return( $Self -> __HTMLDisplayValue() );
}

sub __HTMLDisplayValue
{
	# Find the value in the list and return
	my $Self = shift;

	return( $Self -> { ROWSOURCEHASH } ->
		{ $Self -> _SQLVALUE() } );
}

sub _FillList
{
	# Fills in the list, if needed
	my $Self = shift;

	if( ( $Self -> rowsourcetype() eq "query" ) &&
		( ! $Self -> { listisfull } ) )
	{
		# Fill in the list
		$Self -> rowsourcevalues( [] );
		$Self -> { ROWSOURCEHASH } = {}; # For lookup

		my $sth = $Self -> container() -> dbh() -> prepare( $Self -> rowsourcequery() );
		my( @Row );

		$sth -> execute();

		while( @Row = $sth -> fetchrow_array() )
		{
			push( @{ $Self -> rowsourcevalues() },
					{
						key => shift( @Row ),
						value => join( " ", @Row )
					} );

			$Self -> { ROWSOURCEHASH } ->
				{ $Self -> rowsourcevalues() -> [ -1 ] -> { key } } =
				$Self -> rowsourcevalues() -> [ -1 ] -> { value };
		}
	}
}

1;
